#include <stdio.h>
#include <stdlib.h>
#define FIL 30
#define COL 30
# define NPROD 10
// estructura para guardar los datos. 1 punto
struct producto {
  char nombre [15];
  int bidi [FIL][COL];
  int verdadero;
  int numErr;
};

int inicializar(struct producto prod[]);
int comprobarProducto (struct producto *p);
void obtenerFalsos (struct producto prod[], struct producto falsos[]);
void ordenarProductos (struct producto prod[], int n);
void imprimirInfo(struct producto prod[], int n);


int main(void){
  struct producto prod[NPROD];
  struct producto falsos[NPROD];
  int i, numFalsos=0;
  
  inicializar(prod);
  // comprobar cuantos productos son falsos. 6 puntos
  for (i=0; i<NPROD; i++){
    numFalsos= numFalsos + comprobarProducto (&prod[i]);
  }
 

  
  //Se muestran todos los productos --NO SE PIDE
  
  imprimirInfo(prod, NPROD);
  // Se crea el vector falsos.  
  obtenerFalsos(prod, falsos);
  //Se muestran todos los productos FALSOS--NO SE PIDE
  printf ("Falsos:\n");
  imprimirInfo(falsos, numFalsos);
  
   // ordenarProductos. 2 puntos
  ordenarProductos(falsos,numFalsos);
   
  // MostrarProductos 1 punto
  printf ("A continuacion se muestra el listado de productos falsos \n");
  for (i=0; i<numFalsos; i++){
    printf ( "%s, numero de errores %i\n", falsos[i].nombre, falsos[i].numErr);
    
  }
  system("PAUSE");
  return 0;
}


int comprobarProducto (struct producto *p) {    
// devuelve 1 si el producto es falso, 0 si verdadero
// actualiza numErrores con el numero de errores.

//Pixel=1 -> Blanco;
//Pixwl=0 -> Negro
// Esta parte en conjunto 6 puntos. ver desglose abajo
  int k, f, c, falso = 0;
  int contador1=0, contador2=0, nErrores=0;

  //Primero verificamos los puntos de la fila 7 y contamos los errores. 1 punto
  //Los pixeles, 1 3 y 24 deben ser negros (0).
  nErrores=0;

  if ((*p).bidi[6][1]==1) nErrores ++;
  if ((*p).bidi[6][3]==1) nErrores ++;
  if ((*p).bidi[6][24]==1) nErrores ++;
  
  printf ("Errores Fila 7 =%d\n", nErrores);
  // si no hay errores, comprobamos el resto
  if (nErrores==0) {
  // comprobacin cuadrado blanco (pixel=1) 2 puntos
  //comprobamos columnas de ceros
  // se repite dos veces, para c=0 y para c=COL-1, primera y ultima columnas
    c=0;
    for (k=0;k<1;k++){
       for (f=0; f<FIL; f++){
          if ((*p).bidi[f][c]==0)
             contador1=contador1+1;
       }
       c=COL-1;
    }

    //comprobamos filas de ceros
    // se repite dos veces, para f=0 y para f=FIL-1
    f=0;
    for (k=0;k<1;k++){  
      for (c=0; c<COL; c++){
        if ((*p).bidi[f][c]==0)
           contador1=contador1+1;
      }
      f=FIL-1;
    }
     printf ("Pixeles periferia negros =%d\n", contador1);

    // comprobacin esquina derecha 2 puntos
    // Ahora comprobamos el cuadro de la esquina superior derecha
    // contamos los pixeles que son negros (valor 0), deben ser mas de 25
    for (f=1; f<8; f++){
      for (c=22; c<29; c++){
        if ((*p).bidi[f][c]==0)
          contador2=contador2+1;
      }
    }
    printf ("Pixeles cuadrado 7x7 negros =%d\n", contador2);
  } // fin del if nerr

  // decidir si es falso o no en funcion de criterios. 1 punto
  // el codigo bidi es bueno si los dos contadores estn ok y nErrores=0
  if (((contador1>0)|| (contador2<25)) || (nErrores>0)) {
      falso =1;
  }
  (*p).numErr= nErrores;
  (*p).verdadero=!falso;

  // devuelve 1 si el bidi es falso, 0 si verdadero
  return falso;
}

void obtenerFalsos (struct producto prod[NPROD], struct producto falsos[NPROD]){
   //Completa el vector falsos con todos aquellos codigos falsificados
   int i, j=0;
   for (i=0; i<NPROD; i++){
      if(prod[i].verdadero==0){
          falsos[j]=prod[i];
          j++;
      }
   }
   return;
}
void ordenarProductos (struct producto prod[], int n){
   //Ordena los cdigos falsos por nmero de errores.
   //Como mtodo de ordenacin usamos el de seleccin directa
   int i, j;
   struct producto aux;  
   for(i=0;i<n-1;i++)
   {	//en cada iteracin inicializamos el maximo al primero desordenado 
  	  for(j=i+1;j<n;j++)	
	  {	//comparo cada elemento con el siguiente y 
		//voy quedandome con el menor
		  if (prod[j].numErr > prod[i].numErr)
		  {
			aux=prod[i];
			prod[i]=prod[j];
			prod[j]=aux;
		}
	}
}

  return;
}

int inicializar(struct producto prod[]){
  //NO SE PIDE EN EL ENUNCIADO
  FILE *fc;
  char inputFile[8];
  int i;  //Contador de cdigos
  int f, c; //Contador fila/ columna
  
  strcpy(inputFile, "Bidi.txt");  
  //Se abre el fichero para lectura
  fc = fopen("Bidi.txt", "r");    
    if (fc == NULL) {
       fprintf(stderr, "No se puede abrir el fichero de entrada %s  !\n",inputFile);
     return 1;
    }
 
  //Se leen los 10 cdigos existentes en el fichero.
  for (i=0; i<NPROD; i++){
     //Asignamos nombre, errores y verdadero al cdigo.
     //Por defecto, numErr=0; verdadero=1; 
     sprintf(prod[i].nombre, "%s %d", "Codigo ", i);
     prod[i].numErr=0;
     prod[i].verdadero=1;
     for (f=0; f<FIL; f++){
         for (c=0; c<COL; c++){
            fscanf (fc, "%d",  &prod[i].bidi[f][c]);
         }
     }
  }
  return 0;
}

void imprimirInfo(struct producto prod[], int n){
  int i;
  for (i=0; i<n; i++){
    printf ( "%s, numero de errores %i ", prod[i].nombre, prod[i].numErr);
    if (prod[i].verdadero==1)
         printf ("Verdadero\n");
    else
         printf ("Falso\n");
    }
  return;
}

